defmodule Effusion.Statistics.Supervisor do
  use Supervisor

  @moduledoc """
  Supervises a dynamic number of statistics processes.
  """

  def start_link([]) do
    Supervisor.start_link(__MODULE__, :ok, name: __MODULE__)
  end

  @impl true
  def init(:ok) do
    children = [
      Effusion.Statistics.PeerDownloadAverage,
      Effusion.Statistics.SessionDownloadAverage,
      Effusion.Statistics.SessionUploadAverage,
    ]
    Supervisor.init(children, strategy: :one_for_one)
  end
end
